[[post_data {
    "author" : "KyMAN",
    "since" : 20220402,
    "version" : 20220402
}]]
# Bugs y errores

En esta sección de la Web se detallarán los errores y Bugs encontrados durante el desarrollo y uso
de la herramienta.

## 2022040200 - Redirección IP con Cloudflare y Nginx

A la hora de capturar la dirección IP del usuario sobre Cloudflare nos encontramos con un problema
el cual, el paquete de datos HTTP altera la cabecera al paso por Cloudflare, siendo el cliente
Cloudflare y no el cliente real al que hacemos referencia. Las variables de los datos META también
son alterados, incluyendo el REMOTE_ADDR.

[X] Arreglar el problema con la configuración actual sobre Nginx contra Cloudflare.

> [[! note NOTA]]: Cloudflare agrega un nuevo valor en los META del paquete HTTP llamado
HTTP_CF_CONNECTING_IP, el cual puede ser recogido directamente por PHP mediante $_SERVER o cargado
indirectamente con los datos de cabecera. Se pueden alterar los datos de entrada del REMOTE_ADDR
desde Nginx poniendo como valor dicha cabecera pero al ser accesible desde PHP de esta forma,
simplemente se alterará la cadena de llaves de acceso a las IPs.

```php

$ip = null;

foreach(["HTTP_CF_CONNECTING_IP", "HTTP_X_FORWARDED_FOR", "HTTP_X_REAL_IP", "HTTP_CLIENT_IP", "REMOTE_ADDR"] as $key){
    if(!empty($_SERVER[$key]))
        $ip = explode(",", $_SERVER[$key])[0];
    if($ips = getenv($key))
        $ip = explode(",", $ips)[0];
};

echo $ip;

```

[[html_data {
    "title" : "KStats - Bugs",
    "url" : "https://kstats.k3y.pw/es/bugs.html",
    "author" : "KyMAN",
    "since" : 20220402,
    "version" : 20220402,
    "key_words" : "kstats,stats,statistics,kyman,wmd,wmarkdown,documentación,bugs,fallos,errores,arreglos,problemas,fix",
    "description" : "Bugs y errores del proyecto KStats.",
    "project" : "KStats",
    "logo" : "https://kstats.k3y.pw/images/KStats.png",
    "language" : "es"
}]]
